import { prisma } from "@/module/_global";
import { funGetUserById } from "@/module/auth";
import { createLogUser } from "@/module/user";
import { NextResponse } from "next/server";

export async function GET(request: Request) {
   try {
      const { searchParams } = new URL(request.url);
      const isActive = searchParams.get("active");
      const name = searchParams.get('search');
      const userMobile = searchParams.get("user")

      if (userMobile == "null" || userMobile == undefined || userMobile == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const user = await funGetUserById({ id: userMobile })

      const villaId = user.idVillage

      const data = await prisma.group.findMany({
         where: {
            isActive: isActive == 'false' ? false : true,
            idVillage: String(villaId),
            name: {
               contains: (name == undefined || name == null) ? "" : name,
               mode: "insensitive"
            }
         },
         select: {
            id: true,
            name: true,
            isActive: true
         },
         orderBy: {
            name: 'asc'
         }
      });

      return NextResponse.json({ success: true, message: "Berhasil mendapatkan grup", data, }, { status: 200 });

   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal mendapatkan grup, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
}


export async function POST(request: Request) {
   try {
      const { name, user } = (await request.json());

      if (user == "null" || user == undefined || user == "") {
         return NextResponse.json({ success: false, message: "Anda harus login untuk mengakses ini" }, { status: 200 });
      }

      const userMobile = await funGetUserById({ id: user })

      const villaId = userMobile.idVillage
      const data = await prisma.group.create({
         data: {
            name,
            idVillage: String(villaId)
         },
         select: {
            id: true
         }
      });


      // create log user
      const log = await createLogUser({ act: 'CREATE', desc: 'User membuat data grup', table: 'group', data: data.id })

      return NextResponse.json({ success: true, message: "Berhasil menambahkan grup", }, { status: 200 });
   } catch (error) {
      console.error(error);
      return NextResponse.json({ success: false, message: "Gagal menambahkan grup, coba lagi nanti (error: 500)", reason: (error as Error).message, }, { status: 500 });
   }
};